%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Created_Element_ID = DB_Elm_Create_Bar(Node_1, Node_2)

% Счетчик db_Next_Element_Number обновляется вне данной функции после ее вызова

global db_Next_Element_Number;
global ErrCode;

global DB_ELEMENTS;
global AST_NODES;

global AT_ELEMENTS;
global AT_NODES;

global AT_Page_Prealloc_Size;

Created_Element_ID = [];

% Проверка существования в базе элемента со следующим номером
if (DB_Elm_Exist(db_Next_Element_Number))
    fprintf (1, '\nОшибка функции DB_Elm_Create_Bar: элемент с номером %i уже существует в базе !\n', db_Next_Element_Number);
    ErrCode = -1;
    return;
end

% Проверка существования в базе узла 1
if (~DB_Node_Exist(Node_1))
    fprintf (1, '\nОшибка функции DB_Elm_Create_Bar: узел с номером %i отсутствует в базе !\n', Node_1);
    ErrCode = -1;
    return;
end

% Проверка существования в базе узла 2
if (~DB_Node_Exist(Node_2))
    fprintf (1, '\nОшибка функции DB_Elm_Create_Bar: узел с номером %i отсутствует в базе !\n', Node_2);
    ErrCode = -1;
    return;
end

% Проверка на равенство узлов
if (Node_1 == Node_2)
    fprintf (1, '\nОшибка функции DB_Elm_Create_Bar: указаны совпадающие номера узлов [%i] !\n', Node_1);
    ErrCode = -1;
    return;
end

% Выделение памяти
if (isempty(DB_ELEMENTS))
    AT_ELEMENTS = zeros(AT_Page_Prealloc_Size,1,'uint64');
end
if (db_Next_Element_Number >= size(AT_ELEMENTS,1))
    AT_ELEMENTS(db_Next_Element_Number + AT_Page_Prealloc_Size,1) = 0;
end

% Следующий индекс в базе
Next_DB_index = size(DB_ELEMENTS,1) + 1;

% Создание записи в базе
DB_ELEMENTS{Next_DB_index,1}.type = 'Bar';
DB_ELEMENTS{Next_DB_index,1}.ID = db_Next_Element_Number;
DB_ELEMENTS{Next_DB_index,1}.Prop_ID = [];
DB_ELEMENTS{Next_DB_index,1}.N_nodes = 2;
DB_ELEMENTS{Next_DB_index,1}.Nodes = zeros(2,1);
DB_ELEMENTS{Next_DB_index,1}.Nodes(1) = Node_1;
DB_ELEMENTS{Next_DB_index,1}.Nodes(2) = Node_2;

% Внесение изменений в таблицу ассоциативности узлов
AST_NODES{AT_NODES(DB_ELEMENTS{Next_DB_index}.Nodes(1))}.Elm_list = Union_Column(AST_NODES{AT_NODES(DB_ELEMENTS{Next_DB_index}.Nodes(1))}.Elm_list, db_Next_Element_Number);
AST_NODES{AT_NODES(DB_ELEMENTS{Next_DB_index}.Nodes(2))}.Elm_list = Union_Column(AST_NODES{AT_NODES(DB_ELEMENTS{Next_DB_index}.Nodes(2))}.Elm_list, db_Next_Element_Number);

% Создание ссылки в адресной таблице
AT_ELEMENTS(db_Next_Element_Number) = Next_DB_index;

% Номер созданного элемента
Created_Element_ID = db_Next_Element_Number;
